//    WeIRCd administration tool
//    Copyright (C) 2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

extern void* tablist;
extern char picdir[];
extern char gtkdir[];
extern GtkWidget *mainwindow;
extern int restartscheduled;
void gui_mainwindow_Show();
void gui_mainwindow_menus_Connected(int remote);
void gui_mainwindow_menus_Disconnected();
void gui_mainwindow_menus_NoContext();
void* gui_mainwindow_AddTab(const char* title);
gboolean mainwindow_CheckLocalRunningState(gpointer data);
gboolean mainwindow_CheckLocalPipe(gpointer data);
gboolean mainwindow_CheckStats(gpointer data);
void mainwindowaction_StopServer();
void mainwindowaction_RestartServer();
void mainwindowaction_RehashServer();
int gui_UpdateTabConfig(struct tab* t);
extern int localpid; //the process id of the local running instance

void mainwindow_dlg_AskStopServer();
void mainwindow_dlg_AskRestartServer();

#define TABRECVBUF 2048
struct tab {
	int tab;
	GtkWidget* box;
	struct controlnotebook ct;
	int remote; //if 1 then yes, if 0 then local, if -1 then empty (failed remote)
	int connected; //doesn't matter if local, otherwise 1 if yes, 0 if not, 2 if connecting
	int running; //doesn't matter if not connected, otherwise 1 if running, 0 if not running
	char buf[TABRECVBUF]; //buffer used for sockets or pipes
	char* versionstr; //NULL or null-terminated string containing the WeIRCd version displayed (e.g. "0.7.2")
	int localparsestate;
	//used for local installs where pipes are used:
	PIPEHANDLE readfrompipe; //receive data from weircd
	PIPEHANDLE writetopipe; //pass to weircd so it can write to it
	int havepipes; //1 if pipes are set up
	int restartscheduled; //we do want to restart
	int wanttostop; //we do want to stop (also for restarting) -> deactivate stop/restart buttons
};