//    WeIRCd administration tool
//    Copyright (C) 2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "admintool.h"

struct settingsvar {
	char* name;
	char* value;
};
void* valueslist = NULL;
char currentpath[50] = "";
void fill_start() {
	void* item = valueslist;
	while (item != NULL) {
		struct settingsvar* v = linkedlist_GetData(item);
		if (v->name != NULL) {free(v->name);}
		if (v->value != NULL) {free(v->value);}
		free(v);
		linkedlist_SetData(item,NULL);
		item = linkedlist_NextItem(item);
	}
	linkedlist_Free(&valueslist);
	strcpy(currentpath,"");
}
void fill_openblock(const char* name) {
	char copyval[50];
	strcopy(copyval,name,49);stradd(copyval," ",49),stradd(copyval,"{",49);
	fill_entervar("FORMATTING",copyval);
	if (strlen(currentpath) > 0) {
		stradd(currentpath,"#",49);
	}
	stradd(currentpath,name,49);
}
void fill_closeblock() {
	int r = charposfromright(currentpath,'#');
	if (r >= 0) {
		currentpath[r] = 0;
	}else{
		strcpy(currentpath,"");
	}
	fill_entervar("FORMATTING","}");
}
void fill_entervar(const char* name, const char* value) {
	char* p = malloc(strlen(name)+1+strlen(currentpath)+1);
	if (strlen(currentpath) > 0) {
		strcpy(p,currentpath);
		strcat(p,"#");
	}else{
		strcpy(p,"");
	}
	strcat(p,name);
	struct settingsvar v;
	v.name = p;
	v.value = malloc(strlen(value)+1);strcpy(v.value,value);
	//printf("%s=%s\n",v.name,v.value);
	linkedlist_Append(&valueslist,&v,sizeof(v));
}
void fill_end() {
	strcpy(currentpath,"");
}
const char* value_get(const char* path) {
	void* item = valueslist;
	while (item != NULL) {
		struct settingsvar* v = linkedlist_GetData(item);
		if (v->name != NULL) {
			if (strcasecmp(v->name,path) == 0) {
				return v->value;
			}
		}
		item = linkedlist_NextItem(item);
	}
	return NULL;
}
void value_set(const char* path, const char* value) {
	void* item = valueslist;
	while (item != NULL) {
		struct settingsvar* v = linkedlist_GetData(item);
		if (v->name != NULL) {
			if (strcasecmp(v->name,path) == 0) {
				free(v->value);
				v->value = malloc(strlen(value)+1);
				strcpy(v->value,value);
				return;
			}
		}
		item = linkedlist_NextItem(item);
	}
}
void* lastcycleitem = NULL;
void value_startcycle() {
	lastcycleitem = NULL;
}
int value_cyclenameandvalue(const char** name, const char** value) {
	if (lastcycleitem == NULL) {
		lastcycleitem = valueslist;
	}else{
		lastcycleitem = linkedlist_NextItem(lastcycleitem);
		if (lastcycleitem == NULL) {
			return -1;
		}
	}
	struct settingsvar* v = linkedlist_GetData(lastcycleitem);
	while (v->name == NULL) {
		lastcycleitem = linkedlist_NextItem(lastcycleitem);
		if (lastcycleitem == NULL) {
			return -1;
		}
		v = linkedlist_GetData(lastcycleitem);
	}
	*name = v->name;
	*value = v->value;
	return 0;
}