//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define MAXCHANNELNAMELEN 50
#define MAXTOPICLEN 300
#define MAXBANSPERCHAN 50
#define MAXINVITESPERCHAN 15
#define INVITELEN (60*10)
struct weircd_channelban {
	char* actor;
	char* mask;
	unsigned long time;
};
struct weircd_channelinvite {
	USER target;
	unsigned long time;
};
struct weircd_channel {
	char name[MAXCHANNELNAMELEN + 1];
	char topic[MAXTOPICLEN + 1];
	char topic_setby[50];
	long long topic_settime;
	struct weircd_channelban* ban[MAXBANSPERCHAN];
	struct weircd_channelinvite* invite[MAXINVITESPERCHAN];
	int mode_moderated;
	int mode_topiclock;
	int mode_registered;
	int mode_inviteonly;
	int mode_ircopsonly;
	int mode_blockcolours;
	int mode_private;
	long long creationtime;//needed for link collisions
	int userlimit;
	char* password;
	int hopcount;//needed for linking
	int servlinkid;
	char* servname;
};

typedef void *CHANNEL;
#define NOCHAN NULL


struct weircd_channel* cdat(CHANNEL chan);
void chan_CycleInit();
CHANNEL chan_DoCycle();
CHANNEL chan_FindByName(const char* channame);
CHANNEL chan_Add(const char* channame);
void chan_FreeBan(CHANNEL chan, int banid);
void chan_Delete(CHANNEL id);
void chan_AddInvite(CHANNEL chan, USER target, unsigned long time);
void chan_FreeInvite(CHANNEL chan, int inviteid);
void chan_RemoveOldInvites(CHANNEL chan);
