//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

int irc_IsForbiddenNick(const char* n) {
	if (masklist_CheckItem(reservednicklist,n) >= 0) {
		return 0;
	}
	return -1;
}
void irc_SendStartupNotice(USER userid) {
	//char mask[510];
	//snprintf(mask,509,"ee
	const char* g = glinedbyip(udat(userid)->ip,1);
	if (g != NULL) {
		char snd[500];
		snprintf(snd,499,"ERROR: G-lined: %s",g);
		snd[499] = 0;
		vsnd(snd, userid);
		userQuit(userid,USERQUIT_ERROR);
		return;
	}
	g = glinedbyip(udat(userid)->ip,0);
	if (g != NULL) {
		char snd[500];
		snprintf(snd,499,"ERROR: K-lined: %s",g);
		snd[499] = 0;
		vsnd(snd, userid);
		userQuit(userid,USERQUIT_ERROR);
		return;
	}
	if (ips_Throttled(udat(userid)->ip) == 0) {
		usnd(userid,"ERROR :Throttled: Reconnecting too fast. Please wait 20 seconds.");
		userQuit(userid,USERQUIT_ERROR);
		return;
	}
	if (ips_ClonesAlarm(udat(userid)->ip) == 0) {
		return;
	}
	usnd(userid,"NOTICE AUTH :*** Welcome. Send your authentication");
	
}
void irc_SendAuthPong(USER userid) {
	if (udat(userid)->pleaseremove == 1) {return;}
	if (udat(userid)->authpongvalue > 0) {return;}
	if (udat(userid)->authed == 1) {return;}
	
	strncpy(udat(userid)->host,host_GetDefault(userid),COMPILEOPTION_MAXHOSTLEN-1);
	udat(userid)->host[COMPILEOPTION_MAXHOSTLEN-1] = 0;
	const char* gline = glined(userid,1);
	if (gline != NULL) {
		char snd[500];
		snprintf(snd,499,"ERROR: G-lined: %s",gline);
		snd[499] = 0;
		vsnd(snd, userid);
		userQuit(userid,USERQUIT_ERROR);
		return;
	}
	gline = glined(userid,0);
	if (gline != NULL) {
		char snd[500];
		snprintf(snd,499,"ERROR: K-lined: %s",gline);
		snd[499] = 0;
		vsnd(snd, userid);
		userQuit(userid,USERQUIT_ERROR);
		return;
	}
	
	if (strcasecmp(config_StrVal("pass"),"") !=  0) {
		if (udat(userid)->passwordchecked == 0) {
			usnd(userid,":%s 464 %s :Wrong server password",svname(),udat(userid)->nickname);
			userQuit(userid,USERQUIT_ERROR);
			return;
		}
	}
	long l = ts();
	udat(userid)->authpongvalue = l;
	usnd(userid,"PING :%ld",l);
	return;
}
void irc_MakeUserIdValid(char* userid) {
	char neu[20] = "";
	if (strlen(userid) < 1) {
		strcpy(userid,"");
		return;
	}
	unsigned int fcount2;
	int isokay;
	fcount2 = 0;
	while (fcount2 <= strlen(userid) - 1 && strlen(neu) < 9 && fcount2 < 20) {
		isokay = 0;
		if (userid[fcount2] >= 65 && userid[fcount2] <= 90) {//big letters
			isokay = 1;
		}
		if (userid[fcount2] >= 97 && userid[fcount2] <= 122) {//small letters
			isokay = 1;
		}
		if (userid[fcount2] >= 48 && userid[fcount2] <= 57) {//numbers
			isokay = 1;
		}
		if (userid[fcount2] == 95 && fcount2 >= 1) {//underlined _ - NOT AT THE BEGINNING
			isokay = 1;
		}
		if (isokay == 1) {neu[strlen(neu)+1] = 0;neu[strlen(neu)] = userid[fcount2];}
		fcount2 += 1;
	}
	strcpy(userid,neu);
}
int irc_IsNicknameValid(const char* nick) {
	if (strlen(nick) < 1) {
		return -1;
	}
	unsigned int fcount2;
	int charcount;
	charcount = 0;
	int isokay;
	fcount2 = 0;
	while (fcount2 <= strlen(nick) - 1) {
		isokay = 0;
		if (nick[fcount2] >= 65 && nick[fcount2] <= 90) {//big letters
			isokay = 1;charcount += 1;
		}
		if (nick[fcount2] >= 97 && nick[fcount2] <= 122) {//small letters
			isokay = 1;charcount += 1;
		}
		if (nick[fcount2] >= 48 && nick[fcount2] <= 57 && fcount2 >= 1) {//numbers - NOT AT THE BEGINNING
			isokay = 1;
		}
		if (nick[fcount2] == '_' || nick[fcount2] == '^' || nick[fcount2] == '|' || nick[fcount2] == '[' || nick[fcount2] == ']' || nick[fcount2] == '(' || nick[fcount2] == ')' || nick[fcount2] == '-' || nick[fcount2] == '`' || nick[fcount2] == '\\') {//special chars
			isokay = 1;
		}
		if (isokay == 0) {return -1;}
		fcount2 += 1;
	}
	if (charcount < 0) {return -1;}//'have at least one letter' restriction deactivated! (march 09)
	return 0;
}
int irc_IsNickUsed(const char* nick) {
	if (strlen(nick) < 1) {return -1;}
	usr_CycleInit();
	USER usr = usr_DoCycle();
	while (usr != NULL) {
		if (strcasecmp(udat(usr)->nickname,nick) == 0) {
			return 0;
		}
		usr = usr_DoCycle();
	}
	return -1;
}
void notenoughparameters(USER userid, const char* command) {
	if (strcasecmp(udat(userid)->nickname,"") != 0) {
		usnd(userid,":%s 461 %s %s :Not enough parameters",svname(),udat(userid)->nickname,command);
	}else{
		usnd(userid,":%s 461 %s %s :Not enough parameters",svname(),"AUTH",command);
	}
}
void irc_SendTime(USER userid) {
	usnd(userid,":%s 391 %s %s :%s",svname(),udat(userid)->nickname,svname(),time_GetTimeString(ts()));
}
void irc_SendWhois(USER userid,USER targetid) {
	usnd(userid,":%s 311 %s %s %s %s * :%s",svname(),udat(userid)->nickname,udat(targetid)->nickname,udat(targetid)->suserid,udat(targetid)->host,udat(targetid)->realname);
	/* given it's either ourselves or the requesting person is an IRC op, show the target user's real ip */
	if (userid == targetid || udat(userid)->isircop == 1) {
		usnd(userid,":%s 378 %s %s :is connecting from %s",svname(),udat(userid)->nickname,udat(targetid)->nickname,udat(targetid)->ip);
	}
	char compose[512];
	char linestart[512];
	if (udat(targetid)->mode_servicesbot == 0) {
		/* assemble channel list - given it's not a services bot with a probably huge channel list */
		snprintf(linestart,511,":%s 319 %s %s :",svname(),udat(userid)->nickname,udat(targetid)->nickname);
		linestart[511] = 0;
		strcpy(compose,linestart);
		int composecount = 0;
		usr_chans_CycleInit(targetid);
		void* c = usr_chans_DoCycle();
		while (c != NULL) {
			struct weircd_user_chaninfo* i = usr_chans_GetInfo(c);
			if (cdat(i->cptr)->mode_private != 1 || udat(userid)->isircop == 1) {
				if (strlen(cdat(i->cptr)->name)+2+strlen(compose) > 500 && composecount > 2) {
					usnd(userid,compose);
					strcpy(compose,linestart);
					composecount = 0;
				}
				composecount++;
				if (composecount > 1) {
					stradd(compose," ",511);
				}
				if (i->iamop == 1) {
					stradd(compose,"@",511);
				}else{
					if (i->iamhalfop == 1) {
						stradd(compose,"%",511);
					}else{
						if (i->iamvoice == 1) {
							stradd(compose,"+",511);
						}
					}
				}
				stradd(compose,cdat(i->cptr)->name,511);
			}
			c = usr_chans_DoCycle();
		}
		if (composecount > 0) {
			usnd(userid,compose);
			strcpy(compose,linestart);
			composecount = 0;
		}
	}
	usnd(userid,":%s 312 %s %s %s :%s",svname(),udat(userid)->nickname,udat(targetid)->nickname,svname(),config_StrVal("serverdesc"));
	if (udat(targetid)->awayreason != NULL) {
		if (strcasecmp(udat(targetid)->awayreason,"") != 0) {
			usnd(userid,":%s 301 %s %s :%s",svname(),udat(userid)->nickname,udat(targetid)->nickname,udat(targetid)->awayreason);
		}
	}
	if (udat(targetid)->isircop == 1) {
		usnd(userid,":%s 313 %s %s :is an IRC Operator",svname(),udat(userid)->nickname,udat(targetid)->nickname);
	}
	if (udat(targetid)->mode_bot == 1) {
		usnd(userid,":%s 335 %s %s :is a Bot",svname(),udat(userid)->nickname,udat(targetid)->nickname);
	}
	if (udat(targetid)->mode_servicesbot == 1) {
		usnd(userid,":%s 313 %s %s :is a Network Service",svname(),udat(userid)->nickname,udat(targetid)->nickname);
	}
	if (udat(targetid)->accountname != NULL) {
		usnd(userid,":%s 320 %s %s :is identified as %s",svname(),udat(userid)->nickname,udat(targetid)->nickname,udat(targetid)->accountname);
	}
	usnd(userid,":%s 318 %s %s :End of /WHOIS",svname(),udat(userid)->nickname,udat(targetid)->nickname);
}

//count types see irc.h
int irc_GetUserCount(int type) {
	int k = 0;
	usr_CycleInit();
	USER usr = usr_DoCycle();
	while (usr != NOUSER) {
		if (udat(usr)->pleaseremove == 0 && udat(usr)->authed == 1 && (udat(usr)->hopcount <= 0 || type != COUNT_LOCAL) && (udat(usr)->isircop == 1 || type != COUNT_OPS)) {
			k++;
		}
		usr = usr_DoCycle();
	}
	return k;
}
int irc_GetChannelCount() {
	int k = 0;
	chan_CycleInit();
	CHANNEL c = chan_DoCycle();
	while (c != NOCHAN) {
		k++;
		c = chan_DoCycle();
	}
	return k;
}
int irc_GetServerCount() {
	/*int k = 1;
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			k++;
		}
		r++;
	}
	return k;*/
	return 1;
}
int max_ucount;
int max_ucount_local;
void sendlusers(USER userid) {
	int invis = 0;
	int ucount = irc_GetUserCount(COUNT_ALL);
	int ucount_local = irc_GetUserCount(COUNT_LOCAL);
	if (ucount > max_ucount) {max_ucount = ucount;}
	if (ucount_local > max_ucount_local) {max_ucount_local = ucount_local;}
	#ifndef nowimode
	usnd(userid,":%s 251 %s :There are %d users and %d invisible on %d servers",svname(),udat(userid)->nickname,ucount-invis,invis,irc_GetServerCount());
	#endif
	#ifdef nowimode
	usnd(userid,":%s 251 %s :There are %d users on %d servers",svname(),udat(userid)->nickname,ucount-invis,irc_GetServerCount());
	#endif
	usnd(userid,":%s 252 %s %d :operators online",svname(),udat(userid)->nickname,irc_GetUserCount(COUNT_OPS));
	usnd(userid,":%s 254 %s %d :channels formed",svname(),udat(userid)->nickname,irc_GetChannelCount());
	usnd(userid,":%s 255 %s :I have %d clients and %d servers",svname(),udat(userid)->nickname,irc_GetUserCount(COUNT_LOCAL),irc_GetServerCount());
	usnd(userid,":%s 265 %s :Current local users: %d  Max: %d",svname(),udat(userid)->nickname,ucount_local,max_ucount_local);
	usnd(userid,":%s 266 %s :Current global users: %d  Max: %d",svname(),udat(userid)->nickname,ucount,max_ucount);
}
void irc_SendWho(CHANNEL chan, USER user, USER targetuser) {
	char channame[500];
	if (chan != NOCHAN) {
		strncpy(channame,cdat(chan)->name,499);
		channame[499] = 0;
	}else{
		strcpy(channame,"*");
	}
	char flags[5] = "";
	if (udat(targetuser)->awayreason == NULL) {
		strcpy(flags,"H");
	}else{
		if (strcasecmp(udat(targetuser)->awayreason,"") == 0) {
			strcpy(flags,"H");
		}else{
			strcpy(flags,"G");
		}
	}
	if (udat(targetuser)->isircop == 1) {
		strcat(flags,"*");
	}
	if (chan != NOCHAN) {
		if (isoponchan(targetuser,chan) == 0) {
			strcat(flags,"@");
		}else{
			if (ishoponchan(targetuser,chan) == 0) {
				strcat(flags,"%");
			}else{
				if (isvoiceonchan(targetuser,chan) == 0) {
					strcat(flags,"+");
				}else{
					
				}
			}
		}
	}
	usnd(user,":%s 352 %s %s %s %s %s %s %s :0 %s",svname(),udat(user)->nickname,channame,udat(targetuser)->suserid,udat(targetuser)->host,svname(),udat(targetuser)->nickname,flags ,udat(targetuser)->realname);
}
void irc_Send001(USER userid) {
	char send[501];
	udat(userid)->ping_lastping = ts();
	udat(userid)->authed = 1;
	udat(userid)->lastnickchange = ts();
	usnd(userid,":%s 001 %s :Welcome to %s %s",svname(),udat(userid)->nickname,config_StrVal("network"),udat(userid)->nickname);
	usnd(userid,":%s 002 %s :Your host is %s, running WeIRCd%s",svname(),udat(userid)->nickname,svname(),bigversion);
	usnd(userid,"NOTICE %s :*** Your host is %s, running WeIRCd%s",udat(userid)->nickname,svname(),bigversion);
	usnd(userid,":%s 003 %s :This server was created on a rainy monday",svname(),udat(userid)->nickname);
	#ifndef nowimode
	usnd(userid,":%s 004 %s %s WeIRCd%s BcFhiorSsw bcihklmnOorstv",svname(),udat(userid)->nickname,svname(),bigversion);
	#endif
	#ifdef nowimode
	usnd(userid,":%s 004 %s %s WeIRCd%s BcFhorS bcihklmnOorstv",svname(),udat(userid)->nickname,svname(),bigversion);
	#endif
	usnd(userid,":%s 005 %s CHANTYPES=# PREFIX=(ohv)@%%+ NETWORK=%s AWAYLEN=%d TOPICLEN=%d :are supported by this server",svname(),udat(userid)->nickname,config_StrVal("network"), COMPILEOPTION_MAXAWAYLEN,MAXTOPICLEN);
	usnd(userid,":%s 005 %s CHANLIMIT=#:%d IRCD=WeIRCd NICKLEN=%d CASEMAPPING=ascii USERLEN=9 :are supported by this server",svname(),udat(userid)->nickname,config_IntVal("maxchansperuser"),COMPILEOPTION_MAXNICKLEN);
	usnd(userid,":%s 005 %s CHANMODE=b,kl,,cimnOrst PENALTY MAXTARGETS=1 MAXBANS=%d MODES=%d LISTMODE=%d :are supported by this server",svname(),udat(userid)->nickname,MAXBANSPERCHAN,5,COMPILEOPTION_LISTMODE);//MAXPARAMMODES);
	sendlusers(userid);
	motd_Send(userid);
	usr_SendConnectionNotice(udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,udat(userid)->ip);
	udat(userid)->floodprotect.lastmotd = ts();
	//introduce this user to linked servers
	snprintf(send,499,"adduser :%s %ld",udat(userid)->nickname,ts());send[499] = 0;
	links_Broadcast(send);
	if (udat(userid)->mode_servicesbot == 1) {
		usr_CycleInit();
		void* u = usr_DoCycle();
		while (u != NULL) {
			if (udat(u)->authed == 1 && udat(u)->pleaseremove == 0 && u != userid) {
				usnd(userid,":%s 650 %s %s",svname(),udat(userid)->nickname,udat(u)->nickname);
			}
			u = usr_DoCycle();
		}
	}
	//printf("introducing new user %s\n",udat(userid)->nickname);
}
void sendversion(USER r) {
	#if !defined(osname)
	usnd(r,":%s 351 %s WeIRCd-%s. %s :Generic system",svname(),udat(r)->nickname,version_detail,svname());
	#endif
	#if defined(osname)
	#ifndef SAFEUNIX
	#ifndef WIN
	usnd(r,":%s 351 %s WeIRCd-%s. %s :%s generic",svname(),udat(r)->nickname,version_detail,svname(),osname);
	#endif
	#ifdef WIN
	usnd(r,":%s 351 %s WeIRCd-%s. %s :Windows",svname(),udat(r)->nickname,version_detail,svname());
	#endif
	#endif
	#ifdef SAFEUNIX
	struct utsname u;
	uname(&u);
	usnd(r,":%s 351 %s WeIRCd-%s. %s :%s %s %s",svname(),udat(r)->nickname,version_detail,svname(),u.sysname,u.machine,u.release);
	#endif
	#endif
}
int isvalidchanname(const char* channame) {
	unsigned int r = 0;
	while (r < strlen(channame)) {
		if (channame[r] == '#' || (channame[r] >= 'a' && channame[r] <= 'z') || (channame[r] >= 'A' && channame[r] <= 'Z') || (channame[r] >= '0' && channame[r] <= '9') || channame[r] == '_' || channame[r] == '-' || channame[r] == '.' || channame[r] == '!' || channame[r] == '/' || channame[r] == '\\' || channame[r] == '[' || channame[r] == ']' || channame[r] == '(' || channame[r] == ')' || channame[r] == '?' || channame[r] == '+' || channame[r] == '*' || channame[r] == '<' || channame[r] == '>' || channame[r] == ';') {
			
		}else{
			return -1;
		}
		r += 1;
	}
	return 0;
}
void infol(USER userid, const char* line) {
	usnd(userid,":%s 371 %s :%s",svname(),udat(userid)->nickname,line);
}
void infoend(USER userid) {
	usnd(userid,":%s 374 %s :End of /INFO list",svname(),udat(userid)->nickname);
}
void irc_DoRehash(USER triggeringuser) {
	char msg[300];
	if (triggeringuser != NOUSER) {
		snprintf(msg,299,"[CONFIG] Rehashing (/REHASH used by %s)...",udat(triggeringuser)->nickname);
	}else{
		snprintf(msg,299,"[CONFIG] Rehashing (Triggered by SIGHUP)...");
	}
	msg[299] = 0;
	IOnotice(msg);
	if (readconfig(1) < 0) {
		IOnotice("[CONFIG] Rehashing failed.");
		return;
	}else{
		IOnotice("[CONFIG] Done.");
		return;
	}
}
char infostring[] =
"      <> <>--- WeIRCd (c) by Jonas Thiem ---<> <>\n"
"This IRCd is a chat server software written from scratch,\n"
"founded and mainly  developed by  Jonas 'Elmaron' Thiem.\n"
"\n"
"This program is  free software:  you can redistribute it\n"
"and / or modify it  under the  terms of the  GNU General\n"
"Public  License  v3  as published  by the  Free Software\n"
"Foundation.\n"
"\n"
"Visit  http://eloxoph.com/weircd/  for  additional info.\n"
"\n"
"Special thanks go to:\n"
"  * Marius L. and  Sebastian Schumb for C teaching - you\n"
"     made this possible!\n"
"  * Cathal Ó Broin  for great help  with the  secrets of\n"
"     the IRC protocol\n"
"  * Axel Lehmann for advice and extensive debugging help\n"
"  * All the other persons helping me\n"
"      <> <> <> <>---               ---<> <> <> <>";
void irc_SendInfo(USER u) {
	char buf[400];memset(&buf,0,sizeof(buf));
	char* p = infostring;
	int r = 0;int len = strlen(infostring);
	while (1) {
		len = strlen(p);
		//printf("len %d\n",len);
		if (len > 0) {
			int lbreakfound = 0;
			r = 0;
			while (r < len) {
				if (p[r] == '\n') {
					int copylen = r+1;
					if (copylen > 399) {copylen = 399;}
					memcpy(buf,p,copylen);
					buf[copylen-1] = 0;
					buf[399] = 0;
					infol(u,buf);
					p = p+r+1;
					lbreakfound = 1;
					break;
				}
				r++;
			}
			if (lbreakfound == 0) {
				infol(u,p);
				return;
			}
		}else{
			break;
		}
	}
	infoend(u);
}
void irc_SendNames(USER user, CHANNEL chan) {
	/* Send respective numeric replies to a NAMES command */
	char sendbase[501];
	if (cdat(chan)->hopcount > 0) {
		snprintf(sendbase,499,":%s!%s@%s NAMES %s",udat(user)->nickname,udat(user)->suserid,udat(user)->host,cdat(chan)->name);sendbase[499] = 0;
		links_SendBySID(sendbase,cdat(chan)->servlinkid);
		return;		
	}
	
	snprintf(sendbase,499,":%s 353 %s = %s :",svname(),udat(user)->nickname,cdat(chan)->name);
	sendbase[499] = 0;
	char send[501];
	char pref;
	int c = 0;
	strcpy(send,sendbase);
	usr_CycleInit();
	USER u = usr_DoCycle();
	while (u != NOUSER) {
		if (udat(u)->authed == 1 && udat(u)->pleaseremove == 0) {
			if (usr_IsUserInChan(u,chan) == 0) {
				if (strlen(send) + strlen(udat(u)->nickname) + 2 < 499) {
					c += 1;
					if (c > 1) {strcat(send," ");}
					pref = usr_GetPrefix(u,chan);
					if (pref != 0) {send[strlen(send)+1] = 0;send[strlen(send)] = pref;}
					strcat(send,udat(u)->nickname);
				}else{
					vsnd(send,user);
					strcpy(send,sendbase);
					pref = usr_GetPrefix(u,chan);
					if (pref != 0) {send[strlen(send)+1] = 0;send[strlen(send)] = pref;}
					strcat(send,udat(u)->nickname);
					c = 1;
				}
			}
		}
		u = usr_DoCycle();
	}
	if (c > 0) {vsnd(send,user);}
	usnd(user,":%s 366 %s %s :End of /NAMES list",svname(),udat(user)->nickname,cdat(chan)->name);
}
void irc_SendTopic(USER userid, CHANNEL chan) {
	char send[501];
	if (cdat(chan)->hopcount <= 0) {
		if (cdat(chan)->topic_settime > 0) {//gibtn topic
			usnd(userid,":%s 332 %s %s :%s",svname(),udat(userid)->nickname,cdat(chan)->name,cdat(chan)->topic);
			usnd(userid,":%s 333 %s %s %s %d",svname(),udat(userid)->nickname,cdat(chan)->name,cdat(chan)->topic_setby,cdat(chan)->topic_settime);
			return;
		}else{//gibt kein topic
			usnd(userid,":%s 331 %s %s :No topic is set",svname(),udat(userid)->nickname,cdat(chan)->name);
		}
	}else{
		snprintf(send,500,":%s!%s@%s TOPIC %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,cdat(chan)->name);send[500] = 0;
		links_SendBySID(send,cdat(chan)->servlinkid);
	}
}
void moveoutofchan(USER userid,const char* channame, const char* reason) {
	//parameter "reason" is unused: we don't show PART reasons for spamming purposes etc
	char lclchanname[200];
	char send[501];
	strncpy(lclchanname,channame,199);lclchanname[199] = 0;
	trimleft(lclchanname);cutonfirstspace(lclchanname);
	lclchanname[MAXCHANNELNAMELEN - 1] = 0;
	CHANNEL k = chan_FindByName(lclchanname);
	if (k == NOCHAN) {
		usnd(userid,":%s 442 %s %s :You are not in this channel",svname(),udat(userid)->nickname,lclchanname);
		return;
	}else{
		if (usr_IsUserInChan(userid,k) != 0) {
			usnd(userid,":%s 442 %s %s :You are not in this channel",svname(),udat(userid)->nickname,cdat(k)->name);
			return;
		}else{
			snprintf(send,499,":%s!%s@%s PART %s :",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,cdat(k)->name);
			send[499] = 0;
			if (udat(userid)->hopcount <= 0) {
				usr_TellAllUsersInChan(send,k);
			}else{
				usr_TellAllUsersInChan_Local(send,k);
				//if we get a remote PART, the linking module forwards
				//it to distant servers, so we just notify the local
				//users
			}
			//usr_chans_Print(userid);
			usr_chans_CycleInit(userid);
			void* cinfo = usr_chans_DoCycle();
			while (cinfo != NULL) {
				if (usr_chans_GetInfo(cinfo)->cptr == k) {
					usr_chans_Delete(userid,cinfo);
					break;
				}
				cinfo = usr_chans_DoCycle();
			}
			//usr_chans_Print(userid);
			while (usr_CheckAndRemoveEmptyChans() == 0) { }
		}
	}
}
void localpart(USER userid,const char* channame, const char* reason) {
	/*char send[512];
	printf("processing local part\n");
	int r = getChanID(channame);
	printf("id is %d\n",r);
	if (r >= 0) {
		if (chans[r]->hopcount > 0) {
			snprintf(send,511,":%s!%s@%s PART %s :%s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,chans[r]->name,reason);send[511] = 0;
			sendalllinks(send);
		}
	}*/
	moveoutofchan(userid,channame,reason);
}
void sendlinks(USER userid) {
	usnd(userid,":%s 364 %s %s %s :0 %s",svname(),udat(userid)->nickname,svname(),svname(),config_StrVal("servdesc"));
	/*int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			if (svlinked[r] != NULL) {
				usnd(userid,":%s 364 %s %s %s :%d %s",svname(),udat(userid)->nickname,svnames[r],svlinked[r],svhop[r],svdesc[r]);
			}else{
				usnd(userid,":%s 364 %s %s %s :%d %s",svname(),udat(userid)->nickname,svnames[r],svname(),svhop[r],svdesc[r]);
			}
		}
		r++;
	}*/
	usnd(userid,":%s 365 %s * :End of /LINKS list",svname(),udat(userid)->nickname);
}
int irc_IsValidHost(const char* hostname) {
	if (charpos(hostname,'@') > 0 || charpos(hostname,'!') > 0 || charpos(hostname,'?') > 0 || charpos(hostname,' ') > 0 || charpos(hostname,'"') > 0 || charpos(hostname,'\'') > 0) {
		return -1;
	}
	return 0;
}
void irc_ChangeUserHost(USER userid, const char* hostname) {
	if (strcmp(udat(userid)->host,hostname) == 0) {return;}
	
	char msg[500];
	snprintf(msg,499,":%s!%s@%s QUIT :Changing Host",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host);
	msg[499] = 0;
	usr_TellAffected(msg,userid);
	usr_chans_CycleInit(userid);
	strncpy(udat(userid)->host,hostname,COMPILEOPTION_MAXHOSTLEN-1);
	udat(userid)->host[COMPILEOPTION_MAXHOSTLEN-1] = 0;
	void* item = usr_chans_DoCycle();
	while (item != NULL) {
		struct weircd_user_chaninfo* cinfo = usr_chans_GetInfo(item);
		if (cinfo != NULL) {
			snprintf(msg,499,":%s!%s@%s JOIN %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,cdat(cinfo->cptr)->name);
			msg[499] = 0;
			usr_TellAllUsersInChanExcept(msg,cinfo->cptr,userid);
			if (cinfo->iamop == 1) {
				snprintf(msg,499,":%s MODE %s +o %s",svname(),cdat(cinfo->cptr)->name,udat(userid)->nickname);
				msg[499] = 0;
				usr_TellAllUsersInChanExcept(msg,cinfo->cptr,userid);
			}
			if (cinfo->iamhalfop == 1) {
				snprintf(msg,499,":%s MODE %s +h %s",svname(),cdat(cinfo->cptr)->name,udat(userid)->nickname);
				msg[499] = 0;
				usr_TellAllUsersInChanExcept(msg,cinfo->cptr,userid);
			}
			if (cinfo->iamvoice == 1) {
				snprintf(msg,499,":%s MODE %s +v %s",svname(),cdat(cinfo->cptr)->name,udat(userid)->nickname);
				msg[499] = 0;
				usr_TellAllUsersInChanExcept(msg,cinfo->cptr,userid);
			}
		}
		item = usr_chans_DoCycle();
	}
}
void irc_LocalJoin(USER userid, const char* channame, const char* password) {
	/*char send[512];
	//printf("processing local join\n");
	int r = getChanID(channame);
	printf("id is %d\n",r);
	if (r >= 0) {
			printf("it exists!\n");printf("hopcount is %d\n",chans[r]->hopcount);
			if (chans[r]->hopcount > 0) {
			snprintf(send,511,":%s!%s@%s WANTJOIN %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,chans[r]->name);send[511] = 0;
			sendtoservname(chans[r]->servname,send);
			return;
}
}*/
	moveintochan(userid, channame, password);
}
void irc_ClearRestrictedCacheOfUser(USER u, CHANNEL chan) {
	void* b;
	usr_chans_CycleInit(u);
	b = usr_chans_DoCycle();
	while (b != NULL) {
		struct weircd_user_chaninfo* c = linkedlist_GetData(b);
		if (c->cptr == chan) {
			c->restrictedcache = -1;
			break;
		}
		b = usr_chans_DoCycle();
	}
}
void irc_ClearRestrictedCache(CHANNEL chan) {
	USER u;
	usr_CycleInit();
	u = usr_DoCycle();
	while (u != NOUSER) {
		if (udat(u)->pleaseremove != 1 && udat(u)->authed == 1) {
			irc_ClearRestrictedCacheOfUser(u,chan);
		}
		u = usr_DoCycle();
	}
}
int irc_IsRestricted(USER userid, CHANNEL chan) {
	struct weircd_user_chaninfo* c;
	void* handle = usr_chans_GetHandleByChan(userid,chan);
	if (handle != NULL) {
		c = usr_chans_GetInfo(handle);
	}else{
		return -1;
	}
	if (c != NULL) {
		if (c->restrictedcache >= 0) {
			if (c->restrictedcache == 1) {return 0;}
			return -1;
		}
	}
	int userbanned = 0;
	if (irc_IsUserBanned(userid,chan) == 0) {userbanned = 1;}
	int isrestricted = 0;
	if (userbanned == 1) {
		isrestricted = 1;
		if ((ishoponchan(userid,chan) == 0 || isoponchan(userid,chan) == 0) || udat(userid)->isircop == 1) {
			isrestricted = 0;
		}
	}
	if (isrestricted == 0) {
		if (cdat(chan)->mode_moderated == 1) {
			if (ishoponchan(userid,chan) != 0 && isoponchan(userid,chan) != 0 && isvoiceonchan(userid,chan) != 0 && udat(userid)->isircop == 0) {
				isrestricted = 1;
			}
		}
	}
	if (c != NULL) {
		c->restrictedcache = isrestricted;
	}
	if (isrestricted == 1) {return 0;}
	return -1;
}
int irc_IsUserBanned(USER userid, CHANNEL chan) {
	char mymask[MAXUSERMASKLEN+1];
	snprintf(mymask,MAXUSERMASKLEN,"%s!%s@%s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host);
	mymask[MAXUSERMASKLEN] = 0;
	int j = 0;
	while (j < MAXBANSPERCHAN) 	{
		if (cdat(chan)->ban[j] != NULL) {
			if (masks_Match(mymask,cdat(chan)->ban[j]->mask) == 0) {
				return 0;
			}
		}
		j++;
	}
	return -1;
}
void moveintochan(USER userid,const char* channame, const char* pw) {
	//printf("%s -> %s\n",udat(userid)->nickname,channame);
	char lclchanname[200];
	char send[513];
	strncpy(lclchanname,channame,199);lclchanname[199] = 0;
	trimleft(lclchanname);cutonfirstspace(lclchanname);
	lclchanname[MAXCHANNELNAMELEN - 1] = 0;
	if (udat(userid)->hopcount <= 0) {
		if (isvalidchanname(lclchanname) != 0) {
			usnd(userid,":%s 479 %s %s :Illegal channel name",svname(),udat(userid)->nickname,lclchanname);
			return;
		}
	}
	if (lclchanname[0] != '#') {
		strcpy(send,"#");strcat(send,lclchanname);
		strncpy(lclchanname,send,199);
		lclchanname[199] = 0;
	}
	lclchanname[MAXCHANNELNAMELEN - 1] = 0;
	int max = config_IntVal("maxchansperuser");
	if (max <= 0) {max = 12;}
	if (usr_chans_Count(userid) >= max && udat(userid)->hopcount <= 0 && udat(userid)->mode_servicesbot == 0) {
		usnd(userid,":%s 405 %s %s :You are already in too many channels",svname(),udat(userid)->nickname,lclchanname);
		return;
	}
	int iamop = 0;
	if (udat(userid)->hopcount <= 0) {//if a local user, check for getting opped etc
		if (usr_IsOppedOnJoin(userid,lclchanname) == 0) {
			iamop = 1;
		}
	}
	CHANNEL c = chan_Add(lclchanname);
	if (c == NOCHAN) {
		usnd(userid,":%s 400 %s JOIN :Error - out of memory",svname(),udat(userid)->nickname);
		return;
	}
	if (usr_IsUserInChan(userid,c) == 0) {
		return;
	}
	if (udat(userid)->isircop == 0 && udat(userid)->hopcount <= 0 && udat(userid)->mode_servicesbot == 0) {
		if (irc_IsUserBanned(userid,c) == 0) {
			usnd(userid,":%s 474 %s %s :You're banned from that channel",svname(),udat(userid)->nickname,cdat(c)->name);
			while (usr_CheckAndRemoveEmptyChans() == 0) { }
			return;
		}
	}
	if (udat(userid)->isircop == 0 && cdat(c)->mode_ircopsonly == 1 && udat(userid)->hopcount <= 0 && udat(userid)->mode_servicesbot == 0) {
		usnd(userid,":%s 520 %s %s :Only IRC operators may join (+O)",svname(),udat(userid)->nickname,cdat(c)->name);
		while (usr_CheckAndRemoveEmptyChans() == 0) { }
		return;
	}
	if (udat(userid)->isircop == 0 && cdat(c)->mode_inviteonly == 1 && udat(userid)->hopcount <= 0 && udat(userid)->mode_servicesbot == 0) {
		chan_RemoveOldInvites(c);
		if (usr_AmIInvited(userid,c) < 0) {
			usnd(userid,":%s 473 %s %s :Channel is invite only (+i)",svname(),udat(userid)->nickname,cdat(c)->name);
			while (usr_CheckAndRemoveEmptyChans() == 0) { }
			return;
		}
	}
	if (cdat(c)->password != NULL && udat(userid)->hopcount <= 0 && udat(userid)->mode_servicesbot == 0) {
		int pwok = 0;
		if (pw != NULL) {
			if (strcasecmp(cdat(c)->password,pw) == 0) {
				pwok = 1;
			}
		}
		if (pwok == 0) {
			usnd(userid,":%s 475 %s %s :Channel needs a password (+k)",svname(),udat(userid)->nickname,cdat(c)->name);
			while (usr_CheckAndRemoveEmptyChans() == 0) { }
			return;
		}
	}
	int ucount = usr_ChanUserCount(c);
	if (ucount > 0 && udat(userid)->hopcount <= 0 && udat(userid)->mode_servicesbot == 0) {
		if (ucount >= cdat(c)->userlimit && cdat(c)->userlimit > 0 && udat(userid)->isircop == 0) {
			usnd(userid,":%s 471 %s %s :Channel full (+l)",svname(),udat(userid)->nickname,cdat(c)->name);
			while (usr_CheckAndRemoveEmptyChans() == 0) { }
			return;
		}
	}
	void* item = usr_chans_Add(userid);
	if (item == NULL) {
		usnd(userid,":%s 400 %s JOIN :Error - out of memory",svname(),udat(userid)->nickname);
		while (usr_CheckAndRemoveEmptyChans() == 0) { }
		return;
	}
	usr_RemoveInvite(userid,c);
	usr_chans_GetInfo(item)->cptr = c;//IMPORTANT! feed valid data _before_ calling usr_ChanUserCount()
	usr_chans_GetInfo(item)->iamop = iamop;
	if (usr_ChanUserCount(c) <= 0) {
		//new local channel, introduce it
		snprintf(send,512,"addchan :%s %ld",cdat(c)->name,cdat(c)->creationtime);
		send[511] = 0;
		//sendalllinks(send); TODO links
	}
	snprintf(send,499,":%s!%s@%s JOIN %s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,cdat(c)->name);
	send[499] = 0;
	usr_TellAllUsersInChan_Local(send,c);
	//links_servers_flagusersofchan(r);
	//sendallflagged(send); // TODO links
	irc_SendTopic(userid,c);
	irc_SendNames(userid,c);
	if (iamop == 1) {
		usnd(userid,":%s MODE %s +o %s",svname(),cdat(c)->name,udat(userid)->nickname);
	}
}

void notimplemented(USER userid, const char* command) {
	usnd(userid,":%s 400 %s %s :%s is not implemented yet",svname(),udat(userid)->nickname,command,command);
}
void irc_ParseMsgCMD(USER userid, char* params, const char* type) {
	char response[513];
	trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,type);return;
	}
	if (charpos(params,':') < charpos(params,' ')) {
		notenoughparameters(userid,type);return;
	}
	if (charpos(params,':') >= (signed)strlen(params) - 1) {
		usnd(userid,":%s 412 %s :No text to send",svname(),udat(userid)->nickname);
		return;
	}
	char targets[100];
	strncpy(targets,params,99);targets[99] = 0;
	cutonfirstspace(targets);
	cut(params,charpos(params,' ')+1);
	if (strstw(params,":") != 0) {
		notenoughparameters(userid,type);return;
	}
	cut(params,1);
	if (onlyspaces(params) == 0) {
		usnd(userid,":%s 412 %s :No text to send",svname(),udat(userid)->nickname);
		return;
	}
	if (strstw(targets,"#") == 0) {
		CHANNEL r = chan_FindByName(targets);
		if (r == NOCHAN) {
			usnd(userid,":%s 403 %s %s :No such channel",svname(),udat(userid)->nickname,targets);
			return;
		}else{
			snprintf(response,512,":%s!%s@%s %s %s :%s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,type,cdat(r)->name,params);response[499] = 0;
			response[512] = 0;
			if (usr_IsUserInChan(userid,r) == -1) {
				usnd(userid,":%s 404 %s %s :Cannot send to channel",svname(),udat(userid)->nickname,cdat(r)->name);
				return;
			}else{
				if (irc_IsUserBanned(userid,r) == 0) {
					usnd(userid,":%s 404 %s %s :Cannot send to channel (Banned!)",svname(),udat(userid)->nickname,cdat(r)->name);
					return;
				}
				if (cdat(r)->mode_blockcolours == 1 && (charpos(params,3) >= 0 || charpos(params,22) >= 0)) {
					usnd(userid,":%s 404 %s %s :No colours allowed",svname(),udat(userid)->nickname,cdat(r)->name);
					return;
				}
				if (cdat(r)->mode_moderated == 1 && (isvoiceonchan(userid,r) == -1 && ishoponchan(userid,r) == -1 && isoponchan(userid,r) == -1) && udat(userid)->isircop == 0) {
					usnd(userid,":%s 404 %s %s :Cannot send to channel (+m)",svname(),udat(userid)->nickname,cdat(r)->name);
					return;
				}
				if (irc_IsRestricted(userid,r) == 0) {
					usnd(userid,":%s 404 %s %s :Cannot send to channel (+b)",svname(),udat(userid)->nickname,cdat(r)->name);
					return;
				}
				usr_TellAllUsersInChanExcept(response,r,userid);
				return;
			}
		}
	}else{
		USER u;
		u = usr_FindByNick(targets);
		if (u == NOUSER) {
			usnd(userid,":%s 401 %s %s :No such user",svname(),udat(userid)->nickname,targets);
			return;
		}
		snprintf(response,512,":%s!%s@%s %s %s :%s",udat(userid)->nickname,udat(userid)->suserid,udat(userid)->host,type,udat(u)->nickname,params);
		response[512] = 0;
		if (udat(u)->hopcount <= 0) {
			vsnd(response,u);
		}else{
			links_SendByUID(response,u);
		}
		if (udat(u)->awayreason != NULL) {
			if (strcasecmp(udat(u)->awayreason,"") != 0) {
				usnd(userid,":%s 301 %s %s :%s",svname(),udat(userid)->nickname,udat(u)->nickname,udat(u)->awayreason);
			}
		}
		return;
	}
}
#define MAXPARAMS 15
#define MAXCMDLEN 40
char cmdbuf[MAXPARAMS][MAXCMDLEN];
void irc_UserCMD(USER userid, const char* command, const char* parameters) {
	if (udat(userid)->authed == 1) {
		if ((unsigned)udat(userid)->ping_waitingforpong < ts()-5 && udat(userid)->ping_waitingforpong > 0) {
			udat(userid)->ping_waitingforpong = ts()-5;
		}
	}
	//printf("[%s] %s\n",command,parameters);
	/* Now we want to split up parameters */
	char* parampointers[MAXPARAMS]; /* This will contain pointers to pass to the functions */
	/* Separate the long last parameter and the "normal" parameters in front of it: */
	char longlastparam[512] = "";
	int colonpos = charpos(parameters,':');
	char remainingparams[512];
	if (colonpos >= 0) {
		strcopy(longlastparam,parameters+colonpos+1,511);
		longlastparam[511] = 0;
		strcopy(remainingparams,parameters,511);
		if (colonpos <= 511) {
			remainingparams[colonpos] = 0;
		}
	}else{
		strcopy(remainingparams,parameters,511);
		strcpy(longlastparam,"");
	}
	/* Now cycle through the "normal" parameters and split them up and place them into our buffers: */
	int paramcount = 0;
	int r = 0;
	int k = charpos(remainingparams+r,' ');
	while (k >= 0) { /* we have space chars. we need to break up at every single space char */
		if (k == 0) {
			r++; /* empty param, skip */
		}else{
			int copybytes = MAXCMDLEN-1;
			if (k < copybytes) {copybytes = k;} /* only copy the bytes in front of the space char */
			strcopy(cmdbuf[paramcount], remainingparams+r, copybytes); /* copy parameter */
			paramcount++;
			r += k+1; /* cut space chars from remaining commands list */
			if (paramcount == MAXPARAMS) {break;} /* limit reached */
		}
		k = charpos(remainingparams+r,' ');
	}
	if (strlen(remainingparams+r) > 0 && paramcount < MAXPARAMS) { /* we have a parameter remaining and not yet reached the limit */
		strcopy(cmdbuf[paramcount], remainingparams+r, MAXCMDLEN-1);
		paramcount++;
	}
	/* Now prepare our nice pointers so we can just pass */
	int finalcount = 0; //final parameter count including long last param
	//printf("CMD: %s\n",command);
	r = 0;
	while (r < paramcount) {
		//printf("PARAM: %s\n",cmdbuf[r]);
		parampointers[r] = cmdbuf[r];
		r++;
	}
	finalcount += paramcount;
	if (strlen(longlastparam) > 0) {
		//printf("PARAM: %s\n",longlastparam);
		parampointers[r] = longlastparam;r++;
		finalcount++;
	}
	/* Ok, we got our pointer set "parampointers" ready with as many parameters as in "finalcount" */
	char cmd[40];
	strncpy(cmd,command,39);cmd[39] = 0;
	char params[520];
	strncpy(params,parameters,519);params[519] = 0;
	trimleft(params);
	if (strstw(params,":") == 0) {cut(params,1);trimleft(params);}
	
	/* newstyle: */
	if (strcasecmp(cmd,"WHOIS") == 0) {cmd_whois(userid,parampointers,finalcount);return;}
	if (strcasecmp(cmd,"INVITE") == 0) {cmd_invite(userid,parampointers,finalcount);return;}
	if (strcasecmp(cmd,"MODE") == 0) {cmd_mode(userid,parampointers,finalcount);return;}
	if (strcasecmp(cmd,"USERHOST") == 0) {cmd_userhost(userid,parampointers,finalcount);return;}
	
	/* oldstyle: */
	if (strcasecmp(cmd,"NICK") == 0) {cmd_nick(userid,params);return;}
	if (strcasecmp(cmd,"USER") == 0) {cmd_user(userid,params);return;}
	if (strcasecmp(cmd,"PONG") == 0) {cmd_pong(userid,params);return;}
	if (strcasecmp(cmd,"PRIVMSG") == 0) {udat(userid)->floodprotect.floodpoints += 1;cmd_privmsg(userid,params);return;}
	if (strcasecmp(cmd,"LUSERS") == 0) {
		if (x(userid,"LUSERS")) {return;}
		sendlusers(userid);
		return;
	}
	if (strcasecmp(cmd,"VERSION") == 0) {if (x(userid,"VERSION")) {return;}sendversion(userid);return;}
	if (strcasecmp(cmd,"PING") == 0) {cmd_ping(userid,params);return;}
	if (strcasecmp(cmd,"NOTICE") == 0) {udat(userid)->floodprotect.floodpoints += 1;cmd_notice(userid,params);return;}
	if (strcasecmp(cmd,"LINKS") == 0) {udat(userid)->floodprotect.floodpoints += 1;cmd_links(userid,params);return;}
	if (strcasecmp(cmd,"NAMES") == 0) {cmd_names(userid,params);return;}
	if (strcasecmp(cmd,"JOIN") == 0) {cmd_join(userid,params);return;}
	if (strcasecmp(cmd,"PART") == 0) {cmd_part(userid,params);return;}
	if (strcasecmp(cmd,"OPER") == 0) {cmd_oper(userid,params);return;}
	if (strcasecmp(cmd,"KILL") == 0) {cmd_kill(userid,params);return;}
	if (strcasecmp(cmd,"GLINE") == 0) {cmd_gline(userid,params,1);return;}
	if (strcasecmp(cmd,"KLINE") == 0) {cmd_gline(userid,params,0);return;}
	if (strcasecmp(cmd,"LIST") == 0) {cmd_list(userid,params);return;}
	if (strcasecmp(cmd,"TOPIC") == 0) {cmd_topic(userid,params);return;}
	if (strcasecmp(cmd,"QUIT") == 0) {cmd_quit(userid,params);return;}
	
	
	if (strcasecmp(cmd,"REHASH") == 0) {cmd_rehash(userid,params);return;}
	if (strcasecmp(cmd,"DIE") == 0) {cmd_die(userid,params);return;}
	if (strcasecmp(cmd,"LISTMODE") == 0) {cmd_listmode(userid,params);return;}
	if (strcasecmp(cmd,"PASS") == 0) {cmd_pass(userid,params);return;}
	if (strcasecmp(cmd,"WHO") == 0) {cmd_who(userid,params);return;}
	if (strcasecmp(cmd,"WHOWAS") == 0) {cmd_whowas(userid,params);return;}
	if (strcasecmp(cmd,"ISON") == 0) {cmd_ison(userid,params);return;}
	if (strcasecmp(cmd,"AWAY") == 0) {cmd_away(userid,params);return;}
	if (strcasecmp(cmd,"MODULES") == 0) {cmd_modules(userid,params);return;}
	if (strcasecmp(cmd,"NOTICEALL") == 0) {cmd_noticeall(userid,params);return;}
	if (strcasecmp(cmd,"KICK") == 0) {cmd_kick(userid,params);return;}
	if (strcasecmp(cmd,"TIME") == 0) {cmd_time(userid,params);return;}
	if (strcasecmp(cmd,"SVSNICK") == 0) {cmd_svsnick(userid,params);return;}
	if (strcasecmp(cmd,"SETHOST") == 0) {cmd_sethost(userid,params);return;}
	if (strcasecmp(cmd,"STATS") == 0) {cmd_stats(userid,params);return;}
#ifdef SENDQ
	if (strcasecmp(cmd,"SENDQ") == 0) {cmd_sendq(userid,params);return;}
#endif
	if (strcasecmp(cmd,"INFO") == 0) {cmd_info(userid,params);return;}
	if (strcasecmp(cmd,"WEBIRC") == 0) {cmd_webirc(userid,params);return;}
	if (strcasecmp(cmd,"MOTD") == 0 || strcasecmp(cmd,"RULES") == 0) {cmd_motd(userid,params);return;}
	if (strcasecmp(cmd,"USERS") == 0) {
		usnd(userid,":%s 446 %s :USERS is disabled",svname(),udat(userid)->nickname);return;
	}
	if (strcasecmp(cmd,"SUMMON") == 0) {
		usnd(userid,":%s 445 %s :SUMMON is disabled",svname(),udat(userid)->nickname);return;
	}
	#ifdef SRAW
	if (strcasecmp(cmd,"SRAW") == 0) {cmd_sraw(userid,params);return;}
	#endif
	udat(userid)->floodprotect.floodpoints += 1;
	strupper(cmd);
	if (strcasecmp(udat(userid)->nickname,"") != 0) {
		usnd(userid,":%s 421 %s %s :Command unknown",svname(),udat(userid)->nickname,cmd);
	}else{
		usnd(userid,":%s 421 * %s :Command unknown",svname(),cmd);
	}
}
