//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

char* currmodule = NULL;
int modaccessviolation = 0;
int accessarea = 0;
int doingshutdown = 0;

int module_ShuttingDown() {
	return doingshutdown;
}
void module_DoingShutdown() {
	doingshutdown = 1;
}
void module_ShutdownDone() {
	doingshutdown = 0;
}
void module_Switched(const char* name) {
	modaccessviolation = 0;
	accessarea = 0;
	if (currmodule != NULL) {
		free(currmodule);
	}
	if (name == NULL) {currmodule = NULL;return;}
	currmodule = malloc(strlen(name)+1);
	if (currmodule == NULL) {return;}
	strcpy(currmodule,name);
}
void module_SetArea(int area) {
	accessarea = area;
}
int module_GetArea() {
	return accessarea;
}
int module_AccessAllowed(int area) {
	if (modaccessviolation != 0) {printf("access denied: previous violation\n");return -1;}
	if (currmodule == NULL) {
		modaccessviolation = 1;
		return -1;
	}
	if (accessarea != area) {
		modaccessviolation = 1;
		return -1;
	}
	return 0;
}
int module_AccessViolationHappened() {
	if (modaccessviolation != 0) {return 0;}
	return -1;
}
const char* module_Current() {
	return currmodule;
}